您的位置:首页 > 其它

POJ 3126 BFS-Prime Path

2016-08-02 16:28 274 查看
Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.

— It is a matter of security to change such things every now and then, to keep the enemy in the dark.

— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!

— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.

— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!

— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.

— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.

— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.

— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?

— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179


The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

题意:

将一个四位质数每次变换一位数,变成另一个四位质数,问最少通过多少次这样的变换,可以变换为目标四位质数,注意任何时候这个四位质数的首位不能为0.

题解:

简单的深度优先搜索问题,将四位质数的每一位数从0到9边换并往下搜索,注意四位质数的首位不能取0,且四位质数不可能为偶数,所以个位数智能取奇数。

#include <iostream>
#include <queue>
#include <string.h>
#include <cmath>
#include <stdio.h>
#define MAXN 10000
using namespace std;

int m[4];
queue<int> q;
int vis[MAXN];
int sum;
int num1,num2;
bool isok;

bool isprime(int num)
{
for(int i = 2; i * i <= num; i++)
{
if(num % i == 0)
return false;
}
return true;
}

void bfs()
{
while(!q.empty()) q.pop();
q.push(num1);
while(!q.empty())
{
int u = q.front();
int t2 = u;
q.pop();
for(int i = 0; i < 4; i++)
{
m[i] = u % 10;
u = u / 10;
}
for(int i = 0; i < 4; i++)
{
int t1 = m[i];
for(int j = 0; j < 10; j++)
{
if(i == 0 && j % 2 == 0)
continue;
if(i == 3 && j == 0)
continue;
if(j != t1)
{
m[i] = j;
int temp = 0;
for(int k = 0; k < 4; k++)
temp += m[k] * (int)ceil(pow(10,k));
if(vis[temp] == 0 && isprime(temp))
{
vis[temp] = vis[t2] + 1;
q.push(temp);
if(temp == num2)
{
isok = true;
sum = vis[temp];
return;
}
}
}
}
m[i] = t1;
}
}
}

int main()
{
int t;
cin >> t;
while(t--)
{
cin >> num1 >> num2;
if(num1 == num2)
{
cout << 0 << endl;
continue;
}
memset(vis, 0, sizeof(vis));
isok = false;
sum = 0;
bfs();
if(isok)
cout << sum << endl;
else
cout << "Impossible" << endl;
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  BFS 深度优先搜索